// Gelaende.java                                    MM 2013
import Tools.IO.*;                              // Eingaben

/**
 * Anwendung der Integration zur Berechnung von
 * Gelaendeflaechen, deren Randpunkte bekannt sind.
 * @author Monika Meiler
 */
public class Gelaende
{
/**
 * Eingabe der Randpunkte.
 */
  private double[] konsolenEingabe()
  {
    int s
    = IOTools.readInteger( "Anzahl der Punkte: ");
    System.out.println( s);

    double[] y = new double[ s];
    for( int i = 0; i < s; i++)
    {
      y[ i] = IOTools.readDouble( "y[ " + i + "]= ");
      System.out.println( y[ i]);
    }
    return y;
  }

/* ----------------------------------------------------- */
/**
 * Dialog,
 * Eingabe der Randpunkte (Nordrand, Suedrand),
 * Ausgabe des Gelaendeflaeche.
 */
  public void dialog()
  {
// Ueberschrift
    System.out.println( "Gelaendeberechnung");

// Dialog
    char weiter = 'j';
    do
    {
//Eingabe der Messwerte Gesamtausdehnung
      double xn = IOTools.readDouble( "Gesamtausdehnung: ");
      System.out.println( xn);
      double x0 = 0;

/* ----------------------------------------------------- */
//Eingabe der Messwerte Nordrand
      System.out.println( "Nordrand");
      double[] y = konsolenEingabe();
      double h = ( xn - x0) / ( y.length - 1);
      boolean sim = false;

// Berechnung der Flaechen
      Integral integral = new Integral();

      double trapezN = integral.trapez( y, h);
//    System.out.println( "Trapez  N:  " + trapezN);

      double simpsonN = 0;
      if( y.length % 2 != 0)
      {
        sim = true;
        simpsonN = integral.simpson( y, h);
//      System.out.println( "Simpson N:  " + simpsonN);
      }

/* ------------------------------------------------- */
//Eingabe der Messwerte Suedrand
      System.out.println( "Suedrand");
      y = konsolenEingabe();
      h = ( xn - x0) / ( y.length - 1);

// Berechnung der Flaechen
      double trapezS = integral.trapez( y, h);
//    System.out.println( "Trapez  S:  " + trapezS);

      double simpsonS = 0;
      if( y.length % 2 != 0 && sim)
      {
        simpsonS = integral.simpson( y, h);
//      System.out.println( "Simpson S:  " + simpsonS);
      }
      else sim = false;

// Berechnung der Gesamtflaeche
      double trapez = Math.abs( trapezN - trapezS);
      System.out.println
      ( "Trapez-Flaeche [m^2]:  " + trapez);

      if( sim)
      {
        double simpson = Math.abs( simpsonN - simpsonS);
        System.out.println
        ( "Simpson-Flaeche [m^2]: " + simpson);
      }

// Weiter
      System.out.println();
      weiter
      = IOTools.readChar( "Noch eine Flaeche (j/n)? ");
    } while( weiter == 'j');

    System.out.println();
    System.out.println( "Flaechenberechnung beendet");
  }

/**
 * Starten der Gelaendeberechnung.
 */
  public static void main( String[] args)
  {
// Objekt erzeugen
    Gelaende wald = new Gelaende();
// Berechnung starten
    wald.dialog();
  }
}
/* ---------------------------------------------------- */
                                          // Testbeispiele
/*
Gesamtausdehnung: 4.0
Nordrand
Anzahl der Punkte: 5
y[ 0]= 2.0
y[ 1]= 3.0
y[ 2]= 3.0
y[ 3]= 3.0
y[ 4]= 2.0
Suedrand
Anzahl der Punkte: 5
y[ 0]= 2.0
y[ 1]= 1.0
y[ 2]= 1.0
y[ 3]= 1.0
y[ 4]= 2.0
Trapez-Flaeche [m^2]:  6.0
Simpson-Flaeche [m^2]: 6.666666666666666

Noch eine Flaeche (j/n)? Gesamtausdehnung: 4.0
Nordrand
Anzahl der Punkte: 5
y[ 0]= 2.0
y[ 1]= 3.0
y[ 2]= 3.0
y[ 3]= 3.0
y[ 4]= 2.0
Suedrand
Anzahl der Punkte: 3
y[ 0]= 2.0
y[ 1]= 0.0
y[ 2]= 2.0
Trapez-Flaeche [m^2]:  7.0
Simpson-Flaeche [m^2]: 8.666666666666666

Noch eine Flaeche (j/n)? 

Gesamtausdehnung: 16.0
Nordrand
Anzahl der Punkte: 9
y[ 0]= 4.0
y[ 1]= 5.25
y[ 2]= 5.25
y[ 3]= 5.0
y[ 4]= 5.5
y[ 5]= 5.75
y[ 6]= 5.0
y[ 7]= 4.75
y[ 8]= 3.25
Suedrand
Anzahl der Punkte: 9
y[ 0]= 4.0
y[ 1]= 3.0
y[ 2]= 3.0
y[ 3]= 1.5
y[ 4]= 1.25
y[ 5]= 1.75
y[ 6]= 1.25
y[ 7]= 1.0
y[ 8]= 3.25
Trapez-Flaeche [m^2]:  47.5
Simpson-Flaeche [m^2]: 49.66666666666666

Noch eine Flaeche (j/n)? 
Flaechenberechnung beendet
*/