// SchuettKegel.java                                MM 2013
import Tools.IO.*;                              // Eingaben

/**
 * Anwendung der Cosinusfunktion zur Berechnung von
 * SchuettKegel.
 * @author Monika Meiler
 */
public class SchuettKegel
{
/**
 * Eingabe der Daten (Durchmesser, Winkel)
 * Ausgabe des Volumens
 */
  public static void main( String[] args)
  {
    char weiter = 'j';
    do
    {
//Eingabe der Messdaten
      System.out.println();
      double d
      = IOTools.readDouble( "Durchmesser [m]: ");
      System.out.println( d);
      double wGRD
      = IOTools.readDouble( "Schuettwinkel [GRD]: ");
      System.out.println( wGRD);

// Berechnung des Volumens
      if( d > 0 && wGRD < 90 && wGRD > 0)
      {
        double r = d / 2;                         // Radius

        double wRAD = wGRD * Math.PI / 180;   // GRD -> RAD

        Sinus sin = new Sinus();                 // Volumen
        Cosinus cos = new Cosinus();
        double v = Math.PI/ 3 * r * r * r
                 * sin.wert( wRAD) / cos.wert( wRAD);
        System.out.println( "Volumen [m^3]: " + v);
      }
      else                       // Fehler in den Messdaten
        System.out.println( "Messfehler in der Eingabe");

// Weiter
      System.out.println();
      weiter = IOTools.readChar( "Noch ein Kegel (j/n)? ");
    } while( weiter == 'j');

    System.out.println();
    System.out.println( "Volumenberechnung beendet");
  }
}
/* Schuettwinkel Sand: 33 GRD, Vulkan: 36 GRD */